/*
 | Job Scheduler Tables for Notification with SQL Server 2000, 2005, 2008
 | SOS GmbH, 2018-11-09, robert.ehrlich@sos-berlin.com
*/


SET ANSI_DEFAULTS ON;

/* Table for SCHEDULER_MON_SYSRESULTS */
IF NOT EXISTS (SELECT "ID" FROM sysobjects WHERE "ID" = OBJECT_ID(N''+DB_NAME()+'.'+SCHEMA_NAME()+'.SCHEDULER_MON_SYSRESULTS'))
BEGIN
    
    IF EXISTS (select * from INFORMATION_SCHEMA.TABLES where TABLE_NAME = 'SCHEDULER_MON_CHECKS')
    TRUNCATE TABLE SCHEDULER_MON_CHECKS;
    
    IF EXISTS (select * from INFORMATION_SCHEMA.TABLES where TABLE_NAME = 'SCHEDULER_MON_NOTIFICATIONS')
    TRUNCATE TABLE SCHEDULER_MON_NOTIFICATIONS;
    
    IF EXISTS (select * from INFORMATION_SCHEMA.TABLES where TABLE_NAME = 'SCHEDULER_MON_SYSNOTIFICATIONS')
    TRUNCATE TABLE SCHEDULER_MON_SYSNOTIFICATIONS;
    
    IF EXISTS (select * from INFORMATION_SCHEMA.TABLES where TABLE_NAME = 'SCHEDULER_MON_RESULTS')
    TRUNCATE TABLE SCHEDULER_MON_RESULTS;
        
    CREATE TABLE SCHEDULER_MON_SYSRESULTS(
        "ID"                    NUMERIC(10,0)   IDENTITY(1,1)   NOT NULL,
        "SYS_NOTIFICATION_ID"   NUMERIC(10,0)   NOT NULL,
        "NOTIFICATION_ID"       NUMERIC(10,0)   NOT NULL,
        "ORDER_STEP"            NUMERIC(10,0)   NOT NULL,
        "ORDER_STEP_STATE"      VARCHAR(100)    NOT NULL,
        "CURRENT_NOTIFICATION"  NUMERIC(10,0)   NOT NULL,
        "RECOVERED"             NUMERIC(1)      DEFAULT 0   NOT NULL,
        "CREATED"               DATETIME        NOT NULL,
        "MODIFIED"              DATETIME        NOT NULL,
        CONSTRAINT SCHEDULER_MSR_UNIQ UNIQUE ("SYS_NOTIFICATION_ID","NOTIFICATION_ID"),
        PRIMARY KEY ("ID")
    );
    CREATE INDEX SCHEDULER_MSR_OS    ON SCHEDULER_MON_SYSRESULTS("ORDER_STEP");
END;
SELECT COUNT(*) FROM SCHEDULER_MON_SYSRESULTS;
COMMIT;

