/*
 | Job Scheduler Tables for Notification with MySQL
 | SOS GmbH, 2018-11-09, robert.ehrlich@sos-berlin.com
*/


/* Table for SCHEDULER_MON_SYSRESULTS */
set SQL_MODE=ANSI_QUOTES;

/* Truncate monitoring tables if SCHEDULER_MON_SYSRESULTS not exists */
START TRANSACTION; 
set @count_sysresults       := (SELECT count(*) FROM information_schema.tables WHERE table_name = 'SCHEDULER_MON_SYSRESULTS' and table_schema = database());
set @count_checks           := (SELECT count(*) FROM information_schema.tables WHERE table_name = 'SCHEDULER_MON_CHECKS' and table_schema = database());
set @count_notifications    := (SELECT count(*) FROM information_schema.tables WHERE table_name = 'SCHEDULER_MON_NOTIFICATIONS' and table_schema = database());
set @count_sysnotifications := (SELECT count(*) FROM information_schema.tables WHERE table_name = 'SCHEDULER_MON_SYSNOTIFICATIONS' and table_schema = database());
set @count_results          := (SELECT count(*) FROM information_schema.tables WHERE table_name = 'SCHEDULER_MON_RESULTS' and table_schema = database());
set @stmt := if( @count_sysresults < 1 and @count_checks=1, 'TRUNCATE TABLE SCHEDULER_MON_CHECKS', 'select ''INFO: Table SCHEDULER_MON_CHECKS not found!''');
PREPARE statement FROM @stmt;
EXECUTE statement;
set @stmt := if( @count_sysresults < 1 and @count_notifications=1, 'TRUNCATE TABLE SCHEDULER_MON_NOTIFICATIONS', 'select ''INFO: Table SCHEDULER_MON_NOTIFICATIONS not found!''');
PREPARE statement FROM @stmt;
EXECUTE statement;
set @stmt := if( @count_sysresults < 1 and @count_sysnotifications=1, 'TRUNCATE TABLE SCHEDULER_MON_SYSNOTIFICATIONS', 'select ''INFO: Table SCHEDULER_MON_SYSNOTIFICATIONS not found!''');
PREPARE statement FROM @stmt;
EXECUTE statement;
set @stmt := if( @count_sysresults < 1 and @count_results=1, 'TRUNCATE TABLE SCHEDULER_MON_RESULTS', 'select ''INFO: Table SCHEDULER_MON_RESULTS not found!''');
PREPARE statement FROM @stmt;
EXECUTE statement;
COMMIT;

CREATE TABLE IF NOT EXISTS SCHEDULER_MON_SYSRESULTS(
	"ID"                    INT           NOT NULL    AUTO_INCREMENT,
	"SYS_NOTIFICATION_ID"   INT           NOT NULL,
    "NOTIFICATION_ID"       INT           NOT NULL,
    "ORDER_STEP"            INT           NOT NULL,
    "ORDER_STEP_STATE"      VARCHAR(100)  NOT NULL,
    "CURRENT_NOTIFICATION"  INT           NOT NULL,
	"RECOVERED"             INT(1)        NOT NULL,
	"CREATED"               DATETIME      NOT NULL,
	"MODIFIED"              DATETIME      NOT NULL,
    UNIQUE INDEX SCHEDULER_MSR_UNIQ ("SYS_NOTIFICATION_ID","NOTIFICATION_ID"),
    INDEX SCHEDULER_MSR_OS ("ORDER_STEP"),
    PRIMARY KEY ("ID")
) ENGINE=InnoDB;