/*
 | Job Scheduler Tables for Notification for Oracle
 | SOS GmbH, 2018-11-09, robert.ehrlich@sos-berlin.com
*/

/* Table for SCHEDULER_MON_SYSRESULTS */
DECLARE table_exist number;
BEGIN 
    SELECT COUNT(*) INTO table_exist FROM USER_TABLES WHERE "TABLE_NAME"='SCHEDULER_MON_SYSRESULTS';
    IF (table_exist = 0) THEN 
        EXECUTE IMMEDIATE   'CREATE TABLE SCHEDULER_MON_SYSRESULTS(
                                "ID"                    NUMBER(10)      NOT NULL,
                                "SYS_NOTIFICATION_ID"   NUMBER(10)      NOT NULL,
                                "NOTIFICATION_ID"       NUMBER(10)      NOT NULL,
                                "ORDER_STEP"            NUMBER(9)       NOT NULL,
                                "ORDER_STEP_STATE"      VARCHAR(100)    NOT NULL,
                                "CURRENT_NOTIFICATION"  NUMBER(9)       NOT NULL,
                                "RECOVERED"             NUMBER(1)       NOT NULL,
                                "CREATED"               DATE            NOT NULL,
                                "MODIFIED"              DATE            NOT NULL,
                                CONSTRAINT SCHEDULER_MSR_UNIQ UNIQUE ("SYS_NOTIFICATION_ID","NOTIFICATION_ID"),
                                PRIMARY KEY ("ID")
                            )';
        DECLARE table_n_exist number;
        BEGIN
            SELECT COUNT(*) INTO table_n_exist FROM USER_TABLES WHERE "TABLE_NAME"='SCHEDULER_MON_CHECKS';
            IF (table_n_exist > 0) THEN
                EXECUTE IMMEDIATE 'TRUNCATE TABLE SCHEDULER_MON_CHECKS';
            END IF;
        END;
        DECLARE table_n_exist number;
        BEGIN
            SELECT COUNT(*) INTO table_n_exist FROM USER_TABLES WHERE "TABLE_NAME"='SCHEDULER_MON_NOTIFICATIONS';
            IF (table_n_exist > 0) THEN
                EXECUTE IMMEDIATE 'TRUNCATE TABLE SCHEDULER_MON_NOTIFICATIONS';
            END IF;
        END;
        DECLARE table_n_exist number;
        BEGIN
            SELECT COUNT(*) INTO table_n_exist FROM USER_TABLES WHERE "TABLE_NAME"='SCHEDULER_MON_SYSNOTIFICATIONS';
            IF (table_n_exist > 0) THEN
                EXECUTE IMMEDIATE 'TRUNCATE TABLE SCHEDULER_MON_SYSNOTIFICATIONS';
            END IF;
        END;
        DECLARE table_n_exist number;
        BEGIN
            SELECT COUNT(*) INTO table_n_exist FROM USER_TABLES WHERE "TABLE_NAME"='SCHEDULER_MON_RESULTS';
            IF (table_n_exist > 0) THEN
                EXECUTE IMMEDIATE 'TRUNCATE TABLE SCHEDULER_MON_RESULTS';
            END IF;
        END;
        DECLARE index_exist number;
        BEGIN
            SELECT COUNT(*) INTO index_exist FROM USER_INDEXES WHERE INDEX_NAME = 'SCHEDULER_MSR_OS';
            IF (index_exist = 0) THEN
                EXECUTE IMMEDIATE 'CREATE INDEX SCHEDULER_MSR_OS ON SCHEDULER_MON_SYSRESULTS("ORDER_STEP")';
            END IF;
        END;
        DECLARE sequence_exist number; 
        BEGIN 
            SELECT COUNT(*) INTO sequence_exist FROM USER_SEQUENCES WHERE "SEQUENCE_NAME"='SCHEDULER_MON_SYSR_ID_SEQ'; 
            IF (sequence_exist = 0) THEN 
                EXECUTE IMMEDIATE   'CREATE SEQUENCE SCHEDULER_MON_SYSR_ID_SEQ';          
            END IF; 
        END;
    END IF; 
END;
/
COMMIT;